/*
dttools is Copyright (C) 2002 Douglas Thain
This software is released under the GNU General Public License.
See the file COPYING for details.
*/


#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>        
#include <alloca.h>

#include "debug.h"

int create_dir( const char *path )
{
	char *temp;
	char *delim;
	char oldchar;
	int result;

	temp = alloca(strlen(path)+1);
	strcpy(temp,path);

	delim = temp;

	while( (delim = strchr(delim,'/')) ) {

		if(delim==temp) {
			delim++;
			continue;
		}

		oldchar = *delim;
		*delim = 0;

		result = mkdir(temp,0700);
		if(result!=0) {
			if(errno==EEXIST) {
				/* no problem, keep going */
			} else {
				return 0;
			}
		} else {
			/* ok, made it successfully */
		}

		*delim = oldchar;
		delim++;
	}

	/* Now, last chance */

	result = mkdir(temp,0700);
	if(result!=0) {
		if(errno==EEXIST) {
			return 1;
		} else {
			return 0;
		}
	} else {
		return 1;
	}
}

