/*
dttools is Copyright (C) 2002 Douglas Thain
This software is released under the GNU General Public License.
See the file COPYING for details.
*/

#ifndef INTERVAL_SET_H
#define INTERVAL_SET_H

#include "int_sizes.h"
#include <stdio.h>

typedef UINT64_T interval_set_length_t;
#define INTERVAL_SET_LENGTH_FORMAT UINT64_FORMAT

struct interval_set * interval_set_create();
void interval_set_delete( struct interval_set *s );
int  interval_set_load( struct interval_set *s, FILE *file );
int  interval_set_save( struct interval_set *s, FILE *file );
int  interval_set_add( struct interval_set *s, interval_set_length_t position, interval_set_length_t length );
int  interval_set_contains( struct interval_set *s, interval_set_length_t position, interval_set_length_t length, interval_set_length_t *actual );
void interval_set_nbytes( struct interval_set *s, interval_set_length_t *size );

#endif









