/*
dttools is Copyright (C) 2002 Douglas Thain
This software is released under the GNU General Public License.
See the file COPYING for details.
*/


#include "whois.h"
#include "link.h"
#include "copy_stream.h"
#include "domain_name_cache.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#define WHOIS_PORT 43
#define WHOIS_HOST "rs.internic.net"
#define WHOIS_TIMEOUT 60
#define WHOIS_BUFFER_MAX 65536

char * whois_lookup( const char *key )
{
	struct link *link;
	char addr[DOMAIN_NAME_MAX];
	char buffer[WHOIS_BUFFER_MAX];
	char *value;
	int result;
	char query[DOMAIN_NAME_MAX];
	time_t stoptime = time(0) + WHOIS_TIMEOUT;

	if(!domain_name_cache_lookup(WHOIS_HOST,addr)) return 0;


	link = link_connect(addr,WHOIS_PORT,stoptime);
	if(!link) return 0;

	sprintf(query,"=%s\n",key);

	result = link_write(link,query,strlen(query),stoptime);
	if(result!=strlen(query)) goto failure;

	result = link_read(link,buffer,sizeof(buffer),stoptime);
	if(result>0) {
		value = strdup(buffer);
	} else {
		value = 0;
	}

	link_close(link);

	return value;

	failure:
	link_close(link);
	return 0;
}

char * whois_lookup_full( const char *key )
{
	char *result;

	while(1) {
		result = whois_lookup(key);
		if(result) {
			break;
		} else {
			key = strchr(key,'.');
			if(key) {
				key++;
			} else {
				break;
			}
		}
	}

	return result;
}

